import { CanvasLogicalWidth } from '../Waveform';
import { MouseEvent } from 'react';

// TODO: add tests
export const mouseEventToCanvasX = (
  evt: MouseEvent<HTMLCanvasElement>
): number => {
  // TODO: use offsetX/offsetY?
  const rect = evt.currentTarget.getBoundingClientRect();
  const elementX = evt.clientX - rect.left;
  return (elementX * CanvasLogicalWidth) / rect.width;
};

// TODO: add tests
export const canvasXToFrame = (x: number, numFrames: number): number => {
  return Math.floor((x / CanvasLogicalWidth) * numFrames);
};

// TODO: add tests
export const secsToCanvasX = (
  secs: number,
  sampleRate: number,
  numFrames: number
): number => {
  const duration = numFrames / sampleRate;
  return Math.floor(CanvasLogicalWidth * (secs / duration));
};
